import java.io.*;
import java.util.*;

public class Main {
    public static void main(String[] args) throws IOException {
        int t = nextInt();
        for (int i = 0; i < t; i++) {
            long a = nextLong();
            long b = nextLong();
            long k = nextLong();
            long m = nextLong();
            if (a + b - 2 < k || a * b < m) {
                System.out.println(-1);
                continue;
            }
            TreeSet<Long>myset = new TreeSet<>();
            for (long j = 1; j <= (long) Math.sqrt(m)+500000; j++) {
                if (m%j==0){
                    myset.add(j);
                }
                
            }
            int abc = 0;
            for (int j = 0;!myset.isEmpty();) {
                if (myset.first()<=a && m/myset.first()<=b && myset.first()+m/myset.first()==k+2) {
                    System.out.println(myset.first() - 1 + " " + ((m / myset.first()) - 1));
                    abc++;
                    break;
                }
                myset.remove(myset.first());
            }
            if (abc==0){
                System.out.println(-1);
            }


        }
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}