import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        long p = nextLong();
        long mas[][] = new long[n][3];
        for (int i = 0; i < n; i++) {
            mas[i][0]=nextLong();
            mas[i][1]=nextLong();
            mas[i][2]=nextLong();
        }
        long begin = 0;
        long end = Long.MAX_VALUE/10000000;
        for (int i = 0;begin+1<end; i++) {
            long mid = (begin+end)/2;
            long sum = 0;
            for (int j = 0; j < n; j++) {
                if (mas[j][0]>=mid){
                    sum+=mas[j][1]*mid;
                }else{
                    sum+=mas[j][1]*mas[j][0]+mas[j][2]*(mid-mas[j][0]);
                }
            }
            if (sum>=p){
                end=mid;
            }else{
                begin=mid;
            }
        }
        System.out.print(end);
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter pw = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}